
/*
 * Copyright (c) 1990, William C. Ogden, ogden@nmsu.edu
 *
 * Permission is granted to copy and distribute this file in modified
 * or unmodified form, for noncommercial use, provided (a) this copyright
 * notice is preserved, (b) no attempt is made to restrict redistribution
 * of this file, and (c) this file is not distributed as part of any
 * collection whose redistribution is restricted by a compilation copyright.
 */

#include <stdio.h>
/*#ifdef SUNOS4_1 */
#include <stdlib.h>
/*#endif /* SUNOS4_1 */
#include <sys/file.h>
#include <sys/param.h>
#include <sys/types.h>
#include <unistd.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
/*#include <gdd.h>*/
#include <xview/notice.h>
#include "bt_ui.h"
#include <ctype.h>

#ifndef F_OK
#define F_OK 0
#endif /* F_OK */

extern bt_window1_objects   *bt_window1;
extern bt_listpop_objects	*bt_listpop;
extern bt_loadpop_objects	*bt_loadpop;
extern bt_savepop_objects	*bt_savepop;
extern bt_findpop_objects	*bt_findpop;
extern bt_annotepop_objects	*bt_annotepop;
extern bt_stringpop_objects	*bt_stringpop;
extern bt_nspop_objects	*bt_nspop;
extern bt_expand_objects	*bt_expand;

extern char pathname[MAXPATHLEN], filename[MAXPATHLEN];


#define ABBREVCODE '#'
#define BIBPATHVAR "BIBPATH"
#define FIELDLEFT '{'		/* can be either '{' or '"' */
#define FIELDRIGHT '}'		/* can be either '}' or '"' */




int last_field, edit_count;
/*  the following is declared in bt_ui.h 
#define FIELDSIZ 200
#define ANNOTESIZ 2000


typedef struct ref {
char ref_type[80];
char field[24][FIELDSIZ];

char annote[ANNOTESIZ];
char nsfield[ANNOTESIZ];
struct ref *next;
struct ref *prev;
} Reference, *Ref;
    */
Ref  current_item, last_item, first_item;

char preamble[ANNOTESIZ];

Panel_item field_ptr[26], nxt_fld[26], expand_item;

int    sort_flag, mod_flag,inum,total;

char *months[] = {	"",
			  "#jan",
			  "#feb",
			  "#mar",
			  "#apr",
			  "#may",
			  "#jun",
			  "#jul",
			  "#aug",
			  "#sep",
			  "#oct",
			  "#nov",
			  "#dec"
			};

char *rtypes[] = {	"article",
			  "book",
			  "booklet",
			  "inproceedings",
			  "inbook",
			  "incollection",
			  "manual",
			  "mastersthesis",
			  "phdthesis",
			  "proceedings",
			  "techreport",
			  "unpublished",
			  "misc"
			};


char           *fields[] = {
	"citekey"
	,"author"
	,"address"
	,"booktitle"
	,"chapter"
	,"crossref"
	,"edition"
	,"editor"
	,"howpublished"
	,"institution"
	,"journal"
	,"key"
	,"month"
	,"note"
	,"number"
	,"organization"
	,"pages"
	,"publisher"
	,"school"
	,"series"
	,"title"
	,"type"
	,"volume"
	,"year"
};
void init_field_ptr()
{ 
    field_ptr[0] = bt_window1->citekey;
    field_ptr[1] = bt_window1->author;
    field_ptr[2] = bt_window1->address;
    field_ptr[3] = bt_window1->booktitle;
    field_ptr[4] = bt_window1->chapter;
    field_ptr[5] = bt_window1->crossref;
    field_ptr[6] = bt_window1->edition;
    field_ptr[7] = bt_window1->editor;
    field_ptr[8] = bt_window1->howpublished;
    field_ptr[9] = bt_window1->institution;
    field_ptr[10] = bt_window1->journal;
    field_ptr[11] = bt_window1->key;
    field_ptr[12] = bt_window1->month;
    field_ptr[13] = bt_window1->note;
    field_ptr[14] = bt_window1->number;
    field_ptr[15] = bt_window1->organization;
    field_ptr[16] = bt_window1->pages;
    field_ptr[17] = bt_window1->publisher;
    field_ptr[18] = bt_window1->school;
    field_ptr[19] = bt_window1->series;
    field_ptr[20] = bt_window1->title;
    field_ptr[21] = bt_window1->type;
    field_ptr[22] = bt_window1->volume;
    field_ptr[23] = bt_window1->year;
    
    
    nxt_fld[0] = bt_window1->citekey;
    nxt_fld[1] = bt_window1->key;
    
    xv_set(bt_annotepop->annote_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
    xv_set(bt_nspop->ns_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
    xv_set(bt_expand->ex_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
    /* malloc_debug(2); */
    sort_flag = 0;
    
}

#define CONST
#define SIZET int


char *				/*A case insensitive version of GNU strstr*/
  strcasestr(s, wanted)
CONST char *s;
CONST char *wanted;
{
    register CONST char *scan;
    register SIZET len;
    register char firstc;
    extern int strcmp();
    extern SIZET strlen();
    
    firstc =  ( isupper( *wanted) ? tolower( *wanted) : *wanted);
    len = strlen(wanted);
    for (scan = s; strncasecmp(scan, wanted, len) != 0; ) {
	
	if (*scan++ == '\0')
	  return(NULL);
    }
    return(scan);
}

/* toLower is not very well implemented, because it delets the first character
   of th string 
*/

void toLower(s1)
     
     char * s1;
     
{
    char * aux = s1;
    
    while (*aux)
      *aux++ = isupper(*aux) ? tolower(*aux) : *aux;
    
}


int isNumber(s1)
     
     char * s1;
     
{
    char * aux = s1;
    
    
    while (*aux)
      if (! isdigit(*aux++))
        return(0);
    return(1);
    
}


void
  set_find_fields()

{
    int i,argc;
    char      **avlist;
    
    argc=24;
    
    avlist = (char **) malloc((argc + 4) * sizeof (char *));
    
    avlist[0] = (char *) PANEL_CHOICE_STRINGS;
    for (i = 0; i < argc; i++){
      if ( i == 12)
        avlist[i+1] = (char *) "Month:";
      else
        avlist[i+1] = (char *)  
	  xv_get(field_ptr[i],PANEL_LABEL_STRING);
    }
    avlist[++i] = (char *) "Annotation:";
 
    avlist[++i] = (char *) NULL;   /* NULL-terminate strings */
    avlist[++i] = (char *) NULL;   /* NULL-terminate avlist */
    
    /*
     * Set the scrolling list and free the avlist.
     */
    xv_set(bt_findpop->setting1, ATTR_LIST, avlist, NULL);
    free((char *) avlist);
}

int
  duplicate_cite_key(key)
char * key;
{
    Ref ref;
    
    ref = first_item;
    while (ref != NULL) {
	if (strcasecmp(key,ref->field[0]) == 0)
	  return(1);
	ref = ref->next;
    }
    return(0);
}
int
  standard(field)
char * field;
{
    int	i = 1;
    
    while (i < 24)  
      if (strcmp(field,fields[i++]) == 0)
	return(1);
    
    return(0);
}

void
  find()
{
    extern void show_current_item();
    Ref ref;
    char findstr[80], findfield[ANNOTESIZ];
    int field = (int) xv_get(bt_findpop->setting1,PANEL_VALUE,NULL);
    int n, case_flag;
    
    strcpy(findstr , ( char * ) xv_get(bt_findpop->findstr, PANEL_VALUE));
    case_flag = (int) xv_get(bt_findpop->case_set, PANEL_VALUE);
    
    ref = current_item;
    if (strlen(findstr) > 0) {
	do {
	    ref = ref->next;
	    if (ref == NULL)
	      ref = first_item;
            if (field == 24)
              strcpy(findfield,ref->annote);
            else
              strcpy(findfield,ref->field[field]);
	    if (strlen(findfield) > 0)
	      if ( case_flag ? strcasestr(findfield,findstr) != 0 :
		  strstr(findfield,findstr)  != 0) { 
		  current_item=ref;
		  show_current_item();
		  return;
	      }
	    
	}
	while (ref != current_item);
    }
    notice_prompt(bt_window1->controls1, NULL,
		  NOTICE_MESSAGE_STRINGS,
		  "Not Found",NULL,
		  NOTICE_BUTTON_YES, "Continue",
		  NULL);
    
    
}

void
  update_cite_list()

{  Ref ref;
   int i,n,j,argc;
   char     *avlist[250], *v[1];
   int      rows = xv_get(bt_listpop->list, PANEL_LIST_NROWS);
   
   if ((sort_flag == 1) && (total > 247)) {
       for (j = 0, i = rows - 1; i >= 0; i--) {
	   avlist[j++] = (char *) PANEL_LIST_DELETE;
	   avlist[j++] = (char *) i;
	   if (j > 240) {
	       avlist[j] = (char *) NULL;   /* NULL-terminate avlist */
	       xv_set(bt_listpop->list, ATTR_LIST, avlist, NULL);
	       j = 0;
	   }
	   
	   avlist[j] = (char *) NULL;   /* NULL-terminate avlist */
       }
       /*
	* Delete the excess entries 
	*/
       xv_set(bt_listpop->list, ATTR_LIST, avlist, NULL);
       
       ref = last_item;
       n = 0;
       while ((ref != 0)) {
	   xv_set(bt_listpop->list,
		  PANEL_LIST_INSERT,      n,
		  PANEL_LIST_STRING,      n, ref->field[0],
		  PANEL_PAINT,            PANEL_NONE,
		  0);
	   ref = ref->prev;
       }
       
       xv_set(bt_listpop->list,
	      PANEL_PAINT,    PANEL_CLEAR,
	      0);
       
   }  
   else {  
       argc=total;
       if (argc > 247)
	 argc = 247;
       
       xv_set(bt_listpop->list,
	      PANEL_LIST_STRINGS, " ",NULL,
	      NULL);
       
       avlist[0] = (char *) PANEL_LIST_STRINGS;
       ref = first_item;
       n = 1;
       while ((ref != 0)) {  /* XView limited to 250 attrs */
	   
	   avlist[n++] = ref->field[0];
	   
	   if (n == 247){
	       avlist[n++] = " *** Max list size *** ";
	       break;
	   }
	   ref = ref->next;
       }
       
       if (sort_flag == 0) {
	   /* do an insertion sort */
	   for (i = 2; i <= n-1; i++) {
	       v[0] = avlist[i]; j=i;
	       while (j > 1 && (strcasecmp(avlist[j-1],v[0]) > 0))
		 { avlist[j] = avlist[j-1]; j--; }
	       avlist[j] = v[0];
	   }
       }
       
       avlist[n++] = (char *) NULL;   /* NULL-terminate strings */
       avlist[n++] = (char *) NULL;   /* NULL-terminate avlist */
       
       /*
	* Set the scrolling list and free the avlist.
	*/
       xv_set(bt_listpop->list, ATTR_LIST, avlist, NULL);
       
       /*
	* This should not be necessary, but ... clear any entries
	* in excess of the new entries.
	*/
       if (rows > argc) {
	   /*
	    * Set up an avlist with PANEL_LIST_DELETE,index pairs. The
	    * panel entries are deleted from bottom (high index) to
	    * top (low index) which might reduce copying of entries.
	    */
	   
	   for (j = 0, i = rows - 1; i > argc; i--) {
	       avlist[j++] = (char *) PANEL_LIST_DELETE;
	       avlist[j++] = (char *) i;
	       if (j > 240) {
		   avlist[j] = (char *) NULL;   /* NULL-terminate avlist */
		   xv_set(bt_listpop->list, ATTR_LIST, avlist, NULL);
		   j = 0;
	       }
	   }
	   avlist[j] = (char *) NULL;   /* NULL-terminate avlist */
	   
	   /*
	    * Delete the excess entries 
	    */
	   xv_set(bt_listpop->list, ATTR_LIST, avlist, NULL);
	   
       }
   } 
}

void
  do_title()

{
    
    char  mod[12],title[BUFSIZ];
    
    if (mod_flag) {
	strcpy(mod,"(changed)");
	xv_set(bt_window1->window1,FRAME_NO_CONFIRM, FALSE, 0);
    }
    else  {
	strcpy(mod,""); 
	xv_set(bt_window1->window1,FRAME_NO_CONFIRM, TRUE, 0);
    }
    sprintf(title,"Bib Card: %s %s",filename,mod);
    xv_set(bt_window1->window1,FRAME_LABEL,title,0);
}


char *
  strip_space(s)
char * s;

{
    int j,i=0;
    
    while (s[i] == ' ' || s[i] == '\t')
      i++;
    
    j = strlen(s)-1;
    while (s[j] == ' ' && j>=i)
      s[j--] = '\0';
    
    return s+i;
}

char *
  scan_to_alpha(s)
char * s;
{
    int i=0;
    
    while (! (isalpha(s[i]) || s[i] == '\0')) 
      i++;
    
    return s+i;
}


int count_char(s,c)
     char *s, c;
     
{
    int count=0;
    char t1[ANNOTESIZ], t2[ANNOTESIZ];
    
    strcpy(t1,s);
    while (strchr(t1,c) != 0) {
	strcpy(t2,strchr(t1,c)+1);
	strcpy(t1,t2);
	count++;
    }
    return count;
}

int count_quote(s)
     char *s;
     
{
    int i=0;
    
    while (s[i] != '\0') {
        if ((s[i-1] != '\\') && (s[i] == '"'))
	  return(1);
	i++;
    }
    return(0);
}

int
  writeFile(filename)
char *filename;

{
    char  * str,value[ANNOTESIZ],errmsg[BUFSIZ],tmpfile[MAXPATHLEN];
    FILE * infile;
    int i,j,result;
    Ref ref;
    
    strcpy(value, filename);
    if (strcasecmp(value + (strlen(filename)-4),".bib") == 0)
      sprintf(value,"%s",filename);
    else
      sprintf(value,"%s.bib",filename);
    
    if ( access(value,F_OK ) == 0) {
	sprintf(errmsg, "file %s  already exists\n", value);
	
	result = notice_prompt(bt_window1->controls1, NULL,
			       NOTICE_MESSAGE_STRINGS,
			       errmsg,
			       "OK to overwrite it?",NULL,
			       NOTICE_BUTTON_YES, "OK, Make Backup",
			       NOTICE_BUTTON, "OK, No Backup", 101,
			       NOTICE_BUTTON_NO, "Cancel",
			       NULL);
	if (result == NOTICE_NO) 
	  return(1);
	else if (result == NOTICE_YES) {
	    i = 1;
	    sprintf(tmpfile,"%s.~%d~",value,i);
	    while(access(tmpfile,F_OK) == 0) {
	    	i++;	       			
	    	sprintf(tmpfile,"%s.~%d~",value,i);
	    }
	    sprintf(errmsg,"mv %s %s",value,tmpfile);
	    system(errmsg);
	}     
	
    }
    
    
    if ((infile = fopen(value,"w")) == NULL) {
	sprintf(errmsg, "file %s  could not be opened\n", value);
	
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_MESSAGE_STRINGS,
		      errmsg,NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	
	
	
	return(1);
    }
    if (strlen (preamble) > 0)
      fprintf(infile,"\n@preamble{%s}\n",preamble);
    
    i = (int) xv_get(bt_stringpop->text,TEXTSW_CONTENTS, 0, 
		     value, ANNOTESIZ-1);
    if (i > 0) {
        strtok(value,"\n");
	fprintf(infile,"\n@string{%s}", value);
    	while ((str = (char *) strtok(0,"\n")) != 0)
	  fprintf(infile,"\n@string{%s}\n", str);
    }
    
    ref = first_item;
    while (ref != 0) {
	fprintf(infile,"\n@%s{%s",ref->ref_type, ref->field[0]);
	for (j=1; j < 24; j++) {
	    if (strlen(ref->field[j]) > 0) {
		str = (char *) strip_space(ref->field[j]);
		if ( str[0] != ABBREVCODE )
		  fprintf(infile,",\n   %s = %c%s%c",
			  fields[j],FIELDLEFT,ref->field[j],FIELDRIGHT);
		else
		  fprintf(infile,",\n   %s = %s",
			  fields[j],str+1);
	    }
	    
	}
	if (strlen(ref->annote) > 0)
	  fprintf(infile,",\n  annote = %c%s%c" 
		  ,FIELDLEFT,ref->annote,FIELDRIGHT);
	
	if (strlen(ref->nsfield) > 0)
	  fprintf(infile,",\n  %s",ref->nsfield);
	
	fprintf(infile,"\n}\n");
       	ref = ref->next;
	
    }
    fclose(infile);
    mod_flag = FALSE;
    do_title();
    
}



void
  show_current_item()

{   
    int i;
    
    hide_all();
    
    for (i = 0; i < 24 ; i++){
	xv_set(field_ptr[i],PANEL_VALUE, (*current_item).field[i],0);
    }
    textsw_delete(bt_annotepop->annote_text,0,TEXTSW_INFINITY);
    textsw_reset(bt_annotepop->annote_text,0,0);
    textsw_insert(bt_annotepop->annote_text, (*current_item).annote,strlen((*current_item).annote));
    xv_set(bt_annotepop->annote_text,TEXTSW_FIRST, 0, NULL);
    
    
    textsw_delete(bt_nspop->ns_text,0,TEXTSW_INFINITY);
    textsw_reset(bt_nspop->ns_text,0,0);
    textsw_insert(bt_nspop->ns_text, (*current_item).nsfield,strlen((*current_item).nsfield));
    xv_set(bt_nspop->ns_text,TEXTSW_FIRST, 0, NULL);
    
    edit_count = (int) xv_get(bt_stringpop->text,TEXTSW_EDIT_COUNT);
    
    
    if (strcmp(current_item->ref_type,"article") == 0) {
	xv_set(bt_window1->doc_type, PANEL_VALUE, 0, 0);	
	show_article();
    }
    else if (strcmp(current_item->ref_type,"book") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 1, 0);	
	show_book();
    }
    else if (strcmp(current_item->ref_type,"booklet") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 2, 0);	
	show_booklet();
    }
    else if (strcmp(current_item->ref_type,"inproceedings") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 3, 0);	
	show_inproceedings();
    }
    else if (strcmp(current_item->ref_type,"inbook") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 4, 0);	
	show_inbook();
    }
    else if (strcmp(current_item->ref_type,"incollection") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 5, 0);	
	show_incollection();
    }
    else if (strcmp(current_item->ref_type,"manual") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 6, 0);	
	show_manual();
    }
    else if (strcmp(current_item->ref_type,"mastersthesis") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 7, 0);	
	show_thesis();
    }
    else if (strcmp(current_item->ref_type,"phdthesis") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 8, 0);	
	show_thesis();
    }
    else if (strcmp(current_item->ref_type,"proceedings") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 9, 0);	
	show_proceedings();
    }
    else if (strcmp(current_item->ref_type,"techreport") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 10, 0);	
	show_techreport();
    }
    else if (strcmp(current_item->ref_type,"unpublished") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 11, 0);	
	show_unpublished();
    }
    else {
	xv_set(bt_window1->doc_type, PANEL_VALUE, 12, 0);
	show_misc();
    }
    
    
    xv_set(bt_window1->controls1,PANEL_CARET_ITEM,bt_window1->citekey,0);
    if((int) xv_get(bt_expand->expand,XV_SHOW) == TRUE) {
    	    textsw_delete(bt_expand->ex_text,0,TEXTSW_INFINITY);
   	    textsw_reset(bt_expand->ex_text,0,0);
   	    textsw_insert(bt_expand->ex_text, 
   	        (char *)   xv_get(expand_item,PANEL_VALUE),
   	        strlen((char *) xv_get(expand_item,PANEL_VALUE)));
    	    xv_set(bt_expand->ex_text,TEXTSW_FIRST, 0, NULL);
    }
}

void
  get_path (pathname)
char pathname[];
{
    char *envpathname;
    
    if (envpathname = getenv(BIBPATHVAR))
      {
	  strncpy(pathname,envpathname,MAXPATHLEN-1);
	  pathname[MAXPATHLEN-1] = '\0';
      }
    else
      getwd(pathname);
}

int
  loadFile(filename)
char *filename;

{
    char line[BUFSIZ], field[BUFSIZ], value[ANNOTESIZ], temp[ANNOTESIZ];
    char errmsg[BUFSIZ], abrstr[BUFSIZ] ;
    char * tempstr;
    char obracket, cbracket;
    FILE * infile;
    int    i,n,done,abr;
    Ref  *aux, *ptr1, *ptr2, ref, prev;
    
    inum = -1;
    strcpy(temp, filename);
    if (strcasecmp(temp+ (strlen(filename)-4),".bib") == 0)
      sprintf(temp,"%s",filename);
    else
      sprintf(temp,"%s.bib",filename);
    
    if ((infile = fopen(temp,"r")) == NULL) {
	sprintf(errmsg, "file %s  could not be opened", temp);
	
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_MESSAGE_STRINGS,
		      errmsg,NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	return(1);
    }
    
    /*   first clear the abbrevation panel */
    
    textsw_delete(bt_stringpop->text,0,TEXTSW_INFINITY);
    edit_count = 0;
    
    /* clear preamble */
    preamble[0] = '\0';
    
    /* clear list */
    if (last_item != 0) {
	ref = last_item->prev;
	while (ref != 0) {
	    free(ref->next);
	    ref->next = 0;
	    ref = ref->prev;
	}
    }
    
    first_item = 0;
    
    
    while (fgets(line,BUFSIZ,infile)) {
	/*
	 * Patch added by guenther@ira.uka.de
	 *  now '@' can be found at any start position
	 * (prefixed by some blanks or tabs)
	 */
	char* first_character_pointer;
	first_character_pointer = &line[0];
	while ((*first_character_pointer == ' ') ||
	       (*first_character_pointer == '\t'))
	  first_character_pointer++;
	if (*first_character_pointer == '@') {
	    /*
	     * end-of-patch
	     */
	    value[0]='\0';
	    sscanf(line,"%[^{(]%c%[^,\n]",field,&obracket,value);
	    toLower(field);
	    if (strlen(value) < 1) {
		fgets(line,BUFSIZ,infile);
		sscanf(line,"%[^,]",value);
		
	    }
	    sscanf(value,"%s",value);  
	    sscanf(field,"%s",field);  
	    if (obracket == '(')
	      cbracket = ')';
	    else
	      cbracket = '}';
	    if (strcmp( field+1 , "string") == 0) {  /* found @string */
		strcpy(temp,strstr(line,value));
	      	while (count_char(temp,obracket) >= count_char(temp,cbracket) ){
		    fgets(line,BUFSIZ,infile);
		    if ((strlen(temp) + strlen(line) + 1) > ANNOTESIZ) {
		  	fprintf(stderr, "bibcard: string field too large");
			break;
		    }
		    else
		      strcat(temp,line);
		    
		}  /* end of while */
		if ( strrchr(temp,cbracket) != 0)	
		  temp[strlen(temp)- strlen(strrchr(temp,cbracket))] = '\0';
		if (edit_count > 0)   
		  textsw_insert(bt_stringpop->text,"\n",1);
		textsw_insert(bt_stringpop->text, temp,strlen(temp));
		edit_count = (int) xv_get(bt_stringpop->text,TEXTSW_EDIT_COUNT);
		
	    }  /*  end of @string processing */
	    
	    else if ( strcmp(field+1,"preamble") == 0) { /* found @preamble */
		strcpy(temp,strstr(line,value));
	      	while (count_char(temp,obracket) >= count_char(temp,cbracket) ){
		    fgets(line,BUFSIZ,infile);
		    if ((strlen(temp) + strlen(line) + 1 + strlen(preamble)) > ANNOTESIZ) {
		  	fprintf(stderr, "bibcard: preamble field too large\n");
			break;
		    }
		    else
		      strcat(temp,line);
		    
		}  /* end of while */
		if ( strrchr(temp,cbracket) != 0)	
		  temp[strlen(temp)- strlen(strrchr(temp,cbracket))] = '\0';
		if (strlen(preamble) > 0 ) {
		    strcat(preamble,"\n # ");
		    strcat(preamble,temp);
		    fprintf(stderr, "bibcard: concatenating preamble items\n");
		}
		else
		  strcpy(preamble,temp);
	    }  /* end of preamble */
	    else {  /*  else it is an new item */
		
		inum++;
		
		if ((ref = (Ref) malloc(sizeof(Reference))) == NULL)
		  {   
		      fprintf(stderr, "bibcard: no memory for load\n");
		      exit(0); 
		  }
		bzero((char *) ref,sizeof(Reference));
		
		strcpy(ref->ref_type,field);

/*		toLower(ref->ref_type);*/


		if ((tempstr = (char *) strpbrk(value,"({")) == NULL)
		  tempstr = value;
		else
		  tempstr++;
		strcpy(ref->field[0],strip_space(tempstr));
		if (duplicate_cite_key(tempstr))
		  fprintf(stderr, "bibcard: duplicate cite key: %s\n",tempstr);
		if (first_item == 0) {
		    first_item = ref;
		    prev = ref;
	        }
		else {
		    ref->next = 0;
		    ref->prev = prev;
		    prev->next = ref;
		    prev = ref;
		}
		
	    }  /* end of else it is a new item */
	    
	    
	}  /* end of if line[0] = @ */
	
	else if (strchr(line,'=') != NULL) {
	    tempstr = (char *) scan_to_alpha(line);	
	    sscanf(tempstr,"%[^=]%*c%[^\n]",field,value);
	    
	    sscanf(field,"%s",field);    /* remove leading/trailing space */
	    
	    strcpy(tempstr," ");
	    strcat(tempstr,field);
	    strcpy(field,tempstr);
	    toLower(field);

	    strcpy(temp,strip_space(value));
	    
	    /* check for abbreviation */
	    if (temp[strlen(temp)-1]==',')
	      temp[strlen(temp)-1]='\0';
	    strcpy(abrstr , strip_space(temp));
	    strtok(abrstr,"#");
            abr = 0;		         
	    tempstr = strip_space(abrstr);
	    do {
	    
	      if (strpbrk(tempstr,"\"#%',={}()") == NULL) 
	       	          abr = 1;
	     }
	     while(( tempstr = (char *) strtok(0,"#")) != 0);

	    if (abr == 1) {
	     if (! isNumber(temp))
	          sprintf(abrstr,"%c%s",ABBREVCODE,temp);
	     strcpy(temp,abrstr);

	    }
	    else if (temp[0] == '"') {	/* strip surrounding quotes */
		strcpy(temp,strchr(value,'"')+1);
		while (count_quote(temp) == 0 ) {
		    fgets(line,BUFSIZ,infile);
		    tempstr = strip_space(line);
		    sscanf(tempstr,"%[^\n]",value);
		    if (((strlen(temp) + strlen(value) + 1) > ANNOTESIZ) ||
			(standard(field) && (strlen(temp) + strlen(value) + 1) > FIELDSIZ)) {
		  	fprintf(stderr, "bibcard: the \"%s\" field is too large in item \"%s\"\n", field, ref->field[0]);
			break;
		    }
		    else {
			strcat(temp,"\n ");
			strcat(temp,value);
		    }
		}  /* end of while */
		if ( strrchr(temp,'"') != 0)	
		  temp[strlen(temp)- strlen(strrchr(temp,'"'))] = '\0';
 		tempstr = (char *) strip_space(temp);
		
	    }
	    
	    else if (temp[0] == '{') {	/* or strip surrounding Brackets */
		strcpy(temp,strchr(value,'{')+1);
		while (count_char(temp,'{') >= count_char(temp,'}') ){
		    fgets(line,BUFSIZ,infile);
		    tempstr = strip_space(line);
		    sscanf(tempstr,"%[^\n]",value);
		    /* THIS TEST SHOULD OCCUR FOR SINGLE LINE ENTRIES TOO */
		    if (((strlen(temp) + strlen(value) + 1) > ANNOTESIZ) ||
			(standard(field) && (strlen(temp) + strlen(value) + 1) > FIELDSIZ)) {
		  	fprintf(stderr, "bibcard: the \"%s\" field is too large in item \"%s\"\n", field, ref->field[0]);
			break;
		    }
		    else {
			strcat(temp,"\n ");
			strcat(temp,value);
		    }
		}
		if ( strrchr(temp,'}') != 0)	
		  temp[strlen(temp)- strlen(strrchr(temp,'}'))] = '\0';
		else ;  
 		tempstr = (char *) strip_space(temp);
	    }
	    
	    
	    else if (temp[strlen(temp)-1] == ',') {
		temp[strlen(temp)-1]  = '\0';
	    }
   	    strcpy(value,temp);
	    
	    if (count_char(value,'}') > count_char(value,'{') )
	      value[strlen(value)- strlen(strrchr(value,'}'))] = '\0';
	    if (count_char(value,'>') > count_char(value,'<') )
	      value[strlen(value)- strlen(strrchr(value,'>'))] = '\0';
	    if (count_char(value,')') > count_char(value,'(') )
	      value[strlen(value)- strlen(strrchr(value,')'))] = '\0';
	    
	    if (strlen(field) * strlen(value) > 0) { /* if field and value */
	      i=1;
		while (i< 25) {
		    if ( i == 24 ) {
			if (strcmp(field,"annote") == 0 )
	      	          strcpy(ref->annote,value);
			else {
			    if (strlen(ref->nsfield) > 0)
			      strcat(ref->nsfield,",\n");
			    sprintf(temp,"%s = \"%s\"",field,value);
			    strcat(ref->nsfield,temp);
			}
			break;
		    }
		    if (strcmp(field,fields[i]) == 0) {
			strcpy(ref->field[i],value);
			break;
		    }
		    i++;
		} /* end of while not done */
	    }  /* end of if field and value */
	    
	} /* end of else if len > 0  */
    }  
    last_item = ref;
    total = inum;
    current_item = first_item;
    fclose(infile);
    mod_flag = FALSE;
    show_current_item();
    
    update_cite_list();
    do_title();
    return(0);
    
}
void
 expand(event)
	Event		*event;
{
 int	x,y,width,i;
 char  title[BUFSIZ];
 
 if (event_is_down(event) && event_action(event) == ACTION_SELECT)
  for (i = 0; i < 24 ; i++){
	width = (int) xv_get(field_ptr[i],PANEL_LABEL_WIDTH);
	x = (int) xv_get(field_ptr[i],PANEL_LABEL_X);
	y = (int) xv_get(field_ptr[i],PANEL_LABEL_Y);
	if (event_x(event) > x && event_x(event) < x + width &&
	    event_y(event) > y && event_y(event) < y + 20) {
            sprintf(title,"Expanded field: %s",(char *) xv_get(field_ptr[i], PANEL_LABEL_STRING));
            xv_set(bt_expand->expand,FRAME_LABEL,title,0);
	    xv_set(bt_expand->expand,FRAME_CMD_PUSHPIN_IN,TRUE, XV_SHOW,TRUE,0);
    	    textsw_delete(bt_expand->ex_text,0,TEXTSW_INFINITY);
   	    textsw_reset(bt_expand->ex_text,0,0);
   	    textsw_insert(bt_expand->ex_text, 
   	        (char *)   xv_get(field_ptr[i],PANEL_VALUE),
   	        strlen((char *) xv_get(field_ptr[i],PANEL_VALUE)));
    	    xv_set(bt_expand->ex_text,TEXTSW_FIRST, 0, NULL);
    	    expand_item = field_ptr[i];
       }
    }
}

void 
enter_expanded_text()

{
char  value[FIELDSIZ];
int n;		 


   n = (int) xv_get(bt_expand->ex_text,TEXTSW_CONTENTS, 0, 
		     value, FIELDSIZ-1);
  if (n == FIELDSIZ-1) {
	value[FIELDSIZ-2] = '\0';
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_FOCUS_XY, 318, 7,
		      NOTICE_MESSAGE_STRINGS,
		      "Warning: Maximum Field Size",
		      "Text being truncated",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
    }

  xv_set(expand_item,PANEL_VALUE,value,0);


}


void 
  next_item()

{
    if  (current_item->next == 0)
      current_item = first_item;
    else
      current_item = current_item->next;
    show_current_item();
}


void 
  prev_item()

{
    
    
    if  (current_item->prev == 0)
      current_item = last_item;
    else
      current_item = current_item->prev;
    show_current_item();
}


void 
  add_item()

{    Ref  ref;
     
     total++;
     
     if ((ref = (Reference *)malloc(sizeof(Reference))) == NULL)
       {   
	   fprintf(stderr, "bt: no memory for add");
	   exit(0);
       }
     bzero((char *) ref,sizeof(Reference));
     ref->next = current_item->next;
     ref->prev = current_item;
     if (current_item == last_item)
       last_item = ref;
     else
       current_item->next->prev = ref;
     current_item->next = ref;
     current_item = ref;
     show_current_item();
 }


void 
  delete_item()

{
    int i,n;
    
    total--;
    
    if (last_item == first_item)
      bzero((char *) current_item,sizeof(Reference));
    else if (current_item == last_item) {
	last_item = current_item->prev;
        current_item->prev->next = 0;
        current_item = current_item->prev;
    }
    else if (current_item == first_item) {
	first_item = current_item->next;
	current_item->next->prev = 0;
	current_item = current_item->next;
    }
    
    else {
    	current_item->next->prev = current_item->prev;
    	current_item->prev->next = current_item->next;
   	current_item = current_item->next;
    }
    show_current_item();
    mod_flag=TRUE;
    update_cite_list();
    do_title();
}

void
  save_as()

{
    
    xv_set(bt_savepop->save_dir, PANEL_VALUE,strdup(pathname),0);
    if (strcmp(filename+strlen(pathname)+1,"New") == 0)
      xv_set(bt_savepop->save_file_name, PANEL_VALUE,
	     "",0);
    else
      xv_set(bt_savepop->save_file_name, PANEL_VALUE,
	     strdup(filename+strlen(pathname)+1),0);
    xv_set(bt_savepop->controls4,
	   PANEL_CARET_ITEM,bt_savepop->save_file_name,0);
    xv_set(bt_savepop->savepop, XV_SHOW,TRUE,0);
}

int
  confirm_overwrite()

{    
    int result;
    
    if ( mod_flag ) {
	result =  notice_prompt(bt_window1->controls1, NULL,
				NOTICE_MESSAGE_STRINGS,
				"You have unsaved changes. What do you want to do?",NULL,
				NOTICE_BUTTON_YES, "Save changes",
				NOTICE_BUTTON, "Discard changes", 111,
				NOTICE_BUTTON, "Cancel", 112,
				NULL);
	if (result == NOTICE_YES) 
	  if (strcmp(filename+strlen(pathname)+1,"New") == 0){
	      save_as();
	      return(1);
	  }
	  else
	    return(writeFile(filename));
	else if (result == 111)
	  return(0);
	else
	  return(1);
    }
    else
      return(0);
}


void
  save_button()

{
    xv_set(bt_savepop->savepop, FRAME_BUSY, TRUE);
    sprintf(filename,"%s/%s",
	    (char *) xv_get(bt_savepop->save_dir, PANEL_VALUE),
	    (char *) xv_get(bt_savepop->save_file_name, PANEL_VALUE));
    
    if (writeFile(filename) == 1)
      xv_set(bt_savepop->savepop, FRAME_CMD_PUSHPIN_IN,TRUE,0);
    else
      xv_set(bt_savepop->savepop, FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
    xv_set(bt_savepop->savepop, FRAME_BUSY, FALSE);
}		

void
  load_button()

{	char * tmp;
	xv_set(bt_loadpop->loadpop, FRAME_BUSY, TRUE);
	tmp = (char *) xv_get(bt_loadpop->load_dir, PANEL_VALUE);
	strcpy(pathname,tmp);
	sprintf(filename,"%s/%s",
		tmp,
		(char *) xv_get(bt_loadpop->load_file, PANEL_VALUE));
	
	if (loadFile(filename) == 1)
	  xv_set(bt_loadpop->loadpop, FRAME_CMD_PUSHPIN_IN,TRUE,0);
	else {
	    xv_set(bt_loadpop->loadpop, FRAME_CMD_PUSHPIN_IN,FALSE,0);
	    xv_set(bt_loadpop->loadpop, XV_SHOW,FALSE,0);
	}
	xv_set(bt_loadpop->loadpop, FRAME_BUSY, FALSE);
    }

/*
 * Notify callback function for `monthm'.
 */
void
  month_menu(item, value, event)
Panel_item	item;
int		value;
Event		*event;
{	

    xv_set(bt_window1->month,PANEL_VALUE,
	   months[(int) xv_get(bt_window1->monthm,PANEL_VALUE)],
	   0);
    
}

int  update_item()
     
{
    int  i,n;
    char   value[ANNOTESIZ];
    
    
    for (i= 1; i< 24; i++) {
	strcpy(value , ( char * ) xv_get(field_ptr[i], PANEL_VALUE));
	if (strcmp(current_item->field[i],value) != 0) {
	    strcpy(current_item->field[i],value);
	    mod_flag = TRUE;
	}
    }
    
    n = (int) xv_get(bt_annotepop->annote_text,TEXTSW_CONTENTS, 0, 
		     value, ANNOTESIZ-1);
    if (n == ANNOTESIZ-1) {
	value[ANNOTESIZ-2] = '\0';
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_FOCUS_XY, 318, 7,
		      NOTICE_MESSAGE_STRINGS,
		      "Warning: Maximum Annotation Size",
		      "Text being truncated",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
    }
    
    if (strcmp(current_item->annote,value) != 0) {
	strcpy(current_item->annote,value);
        mod_flag = TRUE;
    }
    
    n = (int) xv_get(bt_nspop->ns_text,TEXTSW_CONTENTS, 0, 
		     value, ANNOTESIZ-1);
    if (n == ANNOTESIZ-1) {
	value[ANNOTESIZ-2] = '\0';
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_FOCUS_XY, 318, 7,
		      NOTICE_MESSAGE_STRINGS,
		      "Warning: Maximum Non-Stardard Field Size",
		      "Text being truncated",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
    }
    
    if (strcmp(current_item->nsfield,value) != 0) {
	strcpy(current_item->nsfield,value);
        mod_flag = TRUE;
    }
    
    n = (int ) xv_get(bt_window1->doc_type, PANEL_VALUE);
    
    if (strcmp(current_item->ref_type,rtypes[n]) != 0) {
 	strcpy(current_item->ref_type,rtypes[n] );
	mod_flag = TRUE;
    }
    
    strcpy(value , ( char * ) xv_get(bt_window1->citekey, PANEL_VALUE));
    if ( strlen(value) < 1) {
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_FOCUS_XY, 318, 7,
		      NOTICE_MESSAGE_STRINGS,
		      "Empty Cite Key",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	return(1);
    }
    
    if (strcmp(current_item->field[0],value) != 0) {
 	mod_flag = TRUE;
    	if (duplicate_cite_key(value)) {
	    notice_prompt(bt_window1->controls1, NULL,
			  NOTICE_FOCUS_XY, 318, 7,
			  NOTICE_MESSAGE_STRINGS,
			  "Duplicate Cite Key",NULL,
			  NOTICE_BUTTON_YES, "Continue",
			  NULL);
	    return(1);
	}
	
	
	strcpy(current_item->field[0],value);
        update_cite_list();
    }
    
    /*  check strings for modifications */
    if (edit_count < (int) xv_get(bt_stringpop->text,TEXTSW_EDIT_COUNT)) {
	
	edit_count = (int) xv_get(bt_stringpop->text,TEXTSW_EDIT_COUNT);
 	mod_flag = TRUE;
    }
    do_title();
    return(0);
}

void
  show_cite(key)
char * key;

{
    Ref ref;
    
    ref = first_item;
    
    while (ref != 0) {
	if (strcmp(key,ref->field[0]) == 0) {
	    current_item = ref;
	    show_current_item();
	    break;
	}	      
	ref = ref->next;
    }
}

void 
  next_field(item)

Panel_item item;

{	int i;

	if (strcmp((char *)xv_get(item,PANEL_LABEL_STRING),
		   "Cross ref key:")==0)
	  xv_set(bt_window1->controls1,
		 PANEL_CARET_ITEM,nxt_fld[0],0);
	else {
	    for (i=0; i<last_field; i++)
	      if (item == nxt_fld[i]) {
		  xv_set(bt_window1->controls1,
			 PANEL_CARET_ITEM,nxt_fld[i+1],0);
		  break;
	      }
	}
	
	
    }

void
  new_bib() 

{
    int  i,n;
    Ref ref;
    
    /* clear list */
    if (last_item != 0) {
	ref = last_item->prev;
	while (ref != 0) {
	    free(ref->next);
	    ref->next = 0;
	    ref = ref->prev;
	}
    }
    
    if ((ref = (Ref) malloc(sizeof(Reference))) == NULL)
      {   
	  fprintf(stderr, "bibcard: no memory for load\n");
	  exit(0); 
      }
    bzero((char *) ref,sizeof(Reference));
    
    first_item = current_item = last_item = ref;
    ref->next = 0;
    ref->prev = 0;
    show_current_item();
    
    /*    clear the abbrevation panel */
    
    textsw_delete(bt_stringpop->text,0,TEXTSW_INFINITY);
    
    /* clear cite list */
    n = (int) xv_get(bt_listpop->list,PANEL_LIST_NROWS);
    if (n > 0)
      for (i = n-1; i >= 0 ; i--)
	xv_set(bt_listpop->list,PANEL_LIST_DELETE, i, 0);
    mod_flag = FALSE;
    get_path(pathname);
    sprintf(filename,"%s/%s",pathname,"New");
    
    do_title();
}



/*
  booklet
  */

show_booklet()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->title;
       
       xv_set(bt_window1->title,    
	      PANEL_VALUE_X, 64,
	      PANEL_VALUE_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1, 
	      XV_X, 8,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->howpublished;
       xv_set(bt_window1->howpublished, 
	      XV_X, 10,
	      XV_Y, 144,
	      XV_SHOW, TRUE,
	      0);
	      
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,   
	      XV_X, 32,
	      XV_Y, 168,
	      XV_SHOW, TRUE,
	      0);
       
       
       nxt_fld[inum++] = bt_window1->year;
       
       xv_set(bt_window1->year, 
	      XV_X, 64,
	      XV_Y, 192,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,  
	      XV_X, 40,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 54,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 131,
	      XV_Y, 246,
	      XV_SHOW, TRUE,
	      0);
       
       
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,  
	      XV_X, 47,
	      XV_Y, 264,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note, 
	      XV_X, 64,
	      XV_Y, 352,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref, 
	      XV_X, 8,
	      XV_Y, 384,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }
/*
  article
  */

show_article()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,
	      XV_X, 31,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 63,
	      XV_Y, 104,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->journal;
       xv_set(bt_window1->journal,    
	      XV_X, 44,
	      XV_Y, 132,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 164,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 196,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 55,
	      XV_Y, 220,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 43,
	      XV_Y, 252,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 39,
	      XV_Y, 284,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 51,
	      XV_Y, 316,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 128,
	      XV_Y, 322,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 52,
	      XV_Y, 348,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref, 
	      XV_X, 31,
	      XV_Y, 384,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

hide_all()
     
{    int  i;
     
     for ( i=1; i<24; i++)
       if ( i != 11)
	 xv_set(field_ptr[i],XV_X, 8,XV_Y, 422,XV_SHOW,FALSE,0);
     
     xv_set(bt_window1->message1,    
	    XV_X, 8,
	    XV_Y, 422,
	    XV_SHOW, FALSE,
	    0);
     xv_set(bt_window1->monthm,    
	    XV_X, 8,
	    XV_Y, 422,
	    XV_SHOW, FALSE,
	    0);
 }
/*
  book
  */

show_book()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 72,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 96,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 32,
	      XV_Y, 120,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 180,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 40,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 48,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 240,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 56,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,    
	      XV_X, 48,
	      XV_Y, 304,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 336,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 128,
	      XV_Y, 342,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 368,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_inbook()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 104,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 56,
	      XV_Y, 128,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->chapter;
       xv_set(bt_window1->chapter,    
	      XV_X, 224,
	      XV_Y, 128,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 29,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 191,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 215,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 48,
	      XV_Y, 239,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 40,
	      XV_Y, 263,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 287,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 128,
	      XV_Y, 293,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,    
	      XV_X, 48,
	      XV_Y, 311,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 40,
	      XV_Y, 335,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 368,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_incollection()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 31,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 104,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->booktitle;
       xv_set(bt_window1->booktitle,    
	      XV_X, 26,
	      XV_Y, 128,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 28,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 176,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 37,
	      XV_Y, 224,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 43,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 283,
	      XV_Y, 249,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 52,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 448,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 525,
	      XV_Y, 254,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,    
	      XV_X, 291,
	      XV_Y, 273,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 55,
	      XV_Y, 296,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->chapter;
       xv_set(bt_window1->chapter,    
	      XV_X, 227,
	      XV_Y, 297,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 40,
	      XV_Y, 320,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 2,
	      XV_Y, 344,
	      
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 376,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 4,
	      XV_Y, 400,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_inproceedings()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 41,
	      XV_Y, 63,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 73,
	      XV_Y, 87,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->booktitle;
       xv_set(bt_window1->booktitle,    
	      XV_X, 33,
	      XV_Y, 111,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 73,
	      XV_Y, 135,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 160,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 46,
	      XV_Y, 183,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 52,
	      XV_Y, 207,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 216,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 61,
	      XV_Y, 231,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 224,
	      XV_Y, 232,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 37,
	      XV_Y, 263,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 49,
	      XV_Y, 295,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->organization;
       xv_set(bt_window1->organization,    
	      XV_X, 15,
	      XV_Y, 319,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->monthm,    
	      XV_X, 61,
	      XV_Y, 343,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 138,
	      XV_Y, 349,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 73,
	      XV_Y, 367,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 17,
	      XV_Y, 391,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_proceedings()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 73,
	      XV_Y, 87,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 73,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);

       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 48,
	      XV_Y, 184,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 52,
	      XV_Y, 207,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 216,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 61,
	      XV_Y, 231,
	      XV_SHOW, TRUE,
	      0);
        nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 37,
	      XV_Y, 263,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 49,
	      XV_Y, 295,
	      XV_SHOW, TRUE,
	      0);

       nxt_fld[inum++] = bt_window1->organization;
       xv_set(bt_window1->organization,    
	      XV_X, 15,
	      XV_Y, 319,
	      XV_SHOW, TRUE,
	      0);
      xv_set(bt_window1->monthm,    
	      XV_X, 61,
	      XV_Y, 343,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month,
       xv_set(bt_window1->month,    
	      XV_X, 138,
	      XV_Y, 349,
	      XV_SHOW, TRUE,
	      0);
	      
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 73,
	      XV_Y, 367,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 17,
	      XV_Y, 391,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }


show_manual()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 144,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1,    
	      XV_X, 2,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 168,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->organization;
       xv_set(bt_window1->organization,    
	      XV_X, 9,
	      XV_Y, 192,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 41,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month,
       xv_set(bt_window1->month,    
	      XV_X, 133,
	      XV_Y, 246,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->edition,    
	      XV_X, 48,
	      XV_Y, 264,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 352,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 384,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_thesis()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 40,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 72,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->school;
       xv_set(bt_window1->school,    
	      XV_X, 59,
	      XV_Y, 144,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 73,
	      XV_Y, 176,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 6,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 61,
	      XV_Y, 304,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 138,
	      XV_Y, 310,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 49,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 73,
	      XV_Y, 360,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 13,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }


show_techreport()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 88,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->institution;
       xv_set(bt_window1->institution,    
	      XV_X, 24,
	      XV_Y, 136,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 72,
	      XV_Y, 160,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 48,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 48,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 16,
	      XV_Y, 320,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 296,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 133,
	      XV_Y, 302,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 72,
	      XV_Y, 368,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_unpublished()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 27,
	      XV_Y, 88,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 56,
	      XV_Y, 120,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 56,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 60,
	      XV_Y, 264,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 48,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 125,
	      XV_Y, 246,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_misc()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 31,
	      XV_Y, 125,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 63,
	      XV_Y, 157,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->howpublished;
       xv_set(bt_window1->howpublished,    
	      XV_X, 2,
	      XV_Y, 189,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 63,
	      XV_Y, 253,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 2,
	      XV_Y, 88,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 47,
	      XV_Y, 221,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 124,
	      XV_Y, 227,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 63,
	      XV_Y, 285,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 2,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }




