
/*
 * Copyright (c) 1990, William C. Ogden, ogden@nmsu.edu
 *
 * Permission is granted to copy and distribute this file in modified
 * or unmodified form, for noncommercial use, provided (a) this copyright
 * notice is preserved, (b) no attempt is made to restrict redistribution
 * of this file, and (c) this file is not distributed as part of any
 * collection whose redistribution is restricted by a compilation copyright.
*/

 
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/notice.h>
#include <xview/svrimage.h>
#include <xview/icon.h>
#include <xview/xv_xrect.h>
/*#include <gdd.h>*/
#include "bt_ui.h"

short my_bits[] = {
#include "bt.icon"
};
#ifdef MAIN

/*
 * Instance XV_KEY_DATA key.  An instance is a set of related
 * user interface objects.  A pointer to an object's instance
 * is stored under this key in every object.  This must be a
 * global variable.
 */
Attr_attribute	INSTANCE;
bt_window1_objects	*bt_window1;
bt_listpop_objects	*bt_listpop;
bt_loadpop_objects	*bt_loadpop;
bt_savepop_objects	*bt_savepop;
bt_findpop_objects	*bt_findpop;
bt_annotepop_objects	*bt_annotepop;
bt_stringpop_objects	*bt_stringpop;
bt_nspop_objects	*bt_nspop;
bt_expand_objects	*bt_expand;

extern Ref current_item, last_item, first_item;
extern int mod_flag, sort_flag;

Menu_item file_menu[8];

char pathname[MAXPATHLEN], filename[MAXPATHLEN];


Notify_value
destroy_func(client, status)
Notify_client client;
Destroy_status status;
{
    if (status == DESTROY_CHECKING) {
	if ( strlen( ( char * ) xv_get(bt_window1->citekey, PANEL_VALUE)) > 0)
               update_item();
	if(confirm_overwrite() == 0){
			if (xv_destroy_safe(bt_window1->window1) == XV_OK)
			   exit(1); /*changed (hb)*/
			}
	 else
	 
            notify_veto_destroy(client);
    } 
    return NOTIFY_DONE;
}

void
main(argc, argv)
	int		argc;
	char		**argv;
{ 
  	
    Server_image	my_image;
    Display		*dpy;
    Icon		icon;
    extern char *getenv();
    extern  int 	set_find_fields();

    char *helppath, buf[BUFSIZ];
 	/*
	 * Initialize XView.
	 */
	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, 0);
	INSTANCE = xv_unique_key();
	
	
	
	/*
	 * Initialize user interface components.
	 */
	bt_window1 = bt_window1_objects_initialize(NULL, NULL);
	bt_listpop = bt_listpop_objects_initialize(NULL, bt_window1->window1);
	bt_loadpop = bt_loadpop_objects_initialize(NULL, bt_window1->window1);
	bt_savepop = bt_savepop_objects_initialize(NULL, bt_window1->window1);
	bt_findpop = bt_findpop_objects_initialize(NULL, bt_window1->window1);
	bt_annotepop = bt_annotepop_objects_initialize(NULL, bt_window1->window1);
	bt_stringpop = bt_stringpop_objects_initialize(NULL, bt_window1->window1);
	bt_nspop = bt_nspop_objects_initialize(NULL, bt_window1->window1);
	bt_expand = bt_expand_objects_initialize(NULL, bt_window1->window1);

    
    my_image = (Server_image)xv_create(NULL, SERVER_IMAGE,
				       XV_WIDTH,	64,
				       XV_HEIGHT,	64,
				       SERVER_IMAGE_BITS, my_bits,
				       NULL);
    
    icon = (Icon)xv_create(NULL, ICON,
			   ICON_IMAGE,	my_image,
			   NULL);

     dpy = (Display *) xv_get(bt_window1->window1, XV_DISPLAY);		  	
    
    notify_interpose_destroy_func(bt_window1->window1, destroy_func);

    xv_set(bt_window1->window1, FRAME_ICON, icon, NULL);

	init_field_ptr();
	hide_all();
	get_path(pathname);
	if (argc > 1) {
            if ((char)argv[1][0] != '/')  /*test for explicit path added by Paul King */
               sprintf(filename,"%s/%s",pathname,argv[1]);
            else
               sprintf(filename,"%s",argv[1]);
		if (loadFile(filename) == 1)
		   new_bib();
	   }
	else
		new_bib();

	set_find_fields();

/*
	sprintf(buf, "HELPPATH=/home/thrinakia1/ogden/Xstuff/bibtex:");
	if (helppath = getenv("HELPPATH"))
		strcat(buf,helppath);
	putenv(buf);

*/	/*
	 * Turn control over to XView.
	 */
	xv_main_loop(bt_window1->window1);
	exit(0);
 
}           

#endif


/*
 * Menu handler for `file_menu'.
 */
Menu
file_menu_handler(menu, op)
	Menu		menu;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(menu, XV_KEY_DATA, INSTANCE);
	int i;
	
	switch (op) {
	case MENU_DISPLAY:
	if ((int)  xv_get(menu, MENU_NITEMS) < 2) {
		for (i = 2; i < 8; i++)
			xv_set(menu,MENU_APPEND_ITEM,file_menu[i],NULL);
		}

        if ( strlen( ( char * ) xv_get(bt_window1->citekey, PANEL_VALUE)) > 0)
		if (update_item() == 1){
		for (i = (int) xv_get(menu, MENU_NITEMS); i > 1; i--) {
			file_menu[i] = (Menu_item) xv_get(menu,MENU_NTH_ITEM,i);
			xv_set(menu, MENU_REMOVE,i, NULL);
			}
		}
	
	if (mod_flag)
		if (strcmp(filename+strlen(pathname)+1,"New") != 0)
			xv_set(menu, MENU_DEFAULT, 4, 0);
		else
 			xv_set(menu, MENU_DEFAULT, 5, 0);
	else
		xv_set(menu, MENU_DEFAULT, 3, 0);

		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return menu;
}

/*
 * Menu handler for `file_menu (New Bib )'.
 */
Menu_item
new_file(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		if(confirm_overwrite() == 0)
			new_bib();
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}


/*
 * Menu handler for `file_menu (Load...)'.
 */
Menu_item
load_file(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		if(confirm_overwrite() == 0) {
		   	xv_set(bt_loadpop->load_dir, PANEL_VALUE,pathname,0);
 		  	xv_set(bt_loadpop->load_file, PANEL_VALUE,
				"",0);
		xv_set(bt_loadpop->controls3,
			PANEL_CARET_ITEM,bt_loadpop->load_file,0);

			xv_set(bt_loadpop->loadpop, XV_SHOW,TRUE,0);
		}
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `file_menu (Save...)'.
 */
Menu_item
save_file(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
	if ((mod_flag) & (strcmp(filename+strlen(pathname)+1,"New") != 0)) 
		xv_set(item, MENU_INACTIVE, FALSE,0);
		   else 
		xv_set(item, MENU_INACTIVE, TRUE,0);
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		writeFile(filename);
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `file_menu (Save As...)'.
 */
Menu_item
save_file_as(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		save_as();
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `file_menu (Revert)'.
 */
Menu_item
revert_file(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	int result;
	
	switch (op) {
	case MENU_DISPLAY:
	if (mod_flag)  
		xv_set(item, MENU_INACTIVE, FALSE,0);
	   else 
		xv_set(item, MENU_INACTIVE, TRUE,0);
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
	   result =  notice_prompt(bt_window1->controls1, NULL,
		    NOTICE_MESSAGE_STRINGS,
		    "Revert will discard changes. What do you want to do?",NULL,
		    NOTICE_BUTTON_YES, "Revert to old file anyway",
		    NOTICE_BUTTON_NO, "Cancel revert", 
		    NULL);
	   if (result == NOTICE_YES)
			loadFile(filename);
 
	   break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `file_menu (Quit)'.
 */
Menu_item
quit_handler(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		if(confirm_overwrite() == 0){
			if (xv_destroy_safe(bt_window1->window1) == XV_OK)
			exit(1);
		}
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `edit_menu (Add new bib item)'.
 */
Menu_item
add_new_item(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		if (update_item() == 0)
			add_item();
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `edit_menu (Delete this item)'.
 */
Menu_item
delete_current_item(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		delete_item();		
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}
/*
 * Menu handler for `edit_menu (Undo changes)'.
 */
Menu_item
undo_changes(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		show_current_item();
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}


/*
 * Menu handler for `view_menu'.
 */
Menu
view(menu, op)
	Menu		menu;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(menu, XV_KEY_DATA, INSTANCE);
   	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		   
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return menu;
}

/*
 * Menu handler for `view_menu (Next)'.
 */
Menu_item
Next(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
	if (current_item == last_item)  
		xv_set(item, MENU_INACTIVE, TRUE,0);
	   else 
		xv_set(item, MENU_INACTIVE, FALSE,0);
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:

		if (update_item() == 0)
		    next_item();
 
		
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `view_menu (Previous)'.
 */
Menu_item
Prev(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
	if (current_item == first_item)  
		xv_set(item, MENU_INACTIVE, TRUE,0);
	   else 
		xv_set(item, MENU_INACTIVE, FALSE,0);
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:

		if (update_item() == 0)
		    prev_item();
 	
		
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}


/*
 * Menu handler for `view_menu (List ...)'.
 */
Menu_item
show_list(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	Rect 	winr, popr, *screenr;
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
	
		screenr = (Rect *) xv_get(bt_window1->window1, WIN_SCREEN_RECT);
		frame_get_rect(bt_listpop->listpop, &popr);
		frame_get_rect(bt_window1->window1, &winr);
		popr.r_top = winr.r_top;
		popr.r_left = winr.r_left + winr.r_width;
		if (popr.r_left + popr.r_width > screenr->r_width)
		  popr.r_left = winr.r_left - popr.r_width;
		if (popr.r_top + popr.r_height > screenr->r_height)
		  popr.r_top = screenr->r_height - popr.r_height;
		
		frame_set_rect(bt_listpop->listpop,&popr);

	        xv_set(bt_listpop->listpop, XV_SHOW,TRUE,0);
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}


/*
 * Menu handler for `view_menu (Find ...)'.
 */
Menu_item
show_find(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		if (update_item() == 0)
		   xv_set(bt_findpop->findpop,XV_SHOW,TRUE,0);
				break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}


/*
 * Menu handler for `view_menu (Annotation ...)'.
 */
Menu_item
show_annote(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	Rect 	winr, popr, *screenr;
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
	
		screenr = (Rect *) xv_get(bt_window1->window1, WIN_SCREEN_RECT);
		frame_get_rect(bt_annotepop->annotepop, &popr);
		frame_get_rect(bt_window1->window1, &winr);
		popr.r_top = winr.r_top + winr.r_height ;
		popr.r_left = winr.r_left;
		if (popr.r_top + popr.r_height > screenr->r_height)
		  popr.r_top = winr.r_top - popr.r_height;
		
		frame_set_rect(bt_annotepop->annotepop,&popr);

		xv_set(bt_annotepop->annotepop,XV_SHOW,TRUE,0);
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `view_menu (Abbreviations ...)'.
 */
Menu_item
show_string_pop(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	Rect 	winr, popr, *screenr;
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		screenr = (Rect *) xv_get(bt_window1->window1, WIN_SCREEN_RECT);
		frame_get_rect(bt_stringpop->stringpop, &popr);
		frame_get_rect(bt_window1->window1, &winr);
		popr.r_top = winr.r_top + 60 ;
		popr.r_left = winr.r_left + 60;
		frame_set_rect(bt_stringpop->stringpop,&popr);

		xv_set(bt_stringpop->stringpop,XV_SHOW,TRUE,0);
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}

/*
 * Menu handler for `view_menu (Other fields ...)'.
 */
Menu_item
show_ns(item, op)
	Menu_item	item;
	Menu_generate	op;
{
	bt_window1_objects * ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	Rect 	winr, popr, *screenr;
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
	
		screenr = (Rect *) xv_get(bt_window1->window1, WIN_SCREEN_RECT);
		frame_get_rect(bt_nspop->nspop, &popr);
		frame_get_rect(bt_window1->window1, &winr);
	        popr.r_top = winr.r_top + 60;
	        popr.r_left = screenr->r_width -  popr.r_width;
		 		
		frame_set_rect(bt_nspop->nspop,&popr);

		xv_set(bt_nspop->nspop,XV_SHOW,TRUE,0);
		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return item;
}


/*
 * Notify callback function for `doc_type'.
 */
void
type_select(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	bt_window1_objects	*ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	hide_all();
 	switch(value){
	case 0 : show_article();
		break;
	case 1: show_book();
		break;
	case 2: show_booklet();
		break;
	case 3: show_inproceedings();
		break;
	case 4: show_inbook();
		break;
	case 5: show_incollection();
		break;
	case 6: show_manual();
		break;
	case 7: show_thesis();
		break;
	case 8: show_thesis();
		break;
	case 9: show_proceedings();
		break;
	case 10: show_techreport();
		break;
	case 11: show_unpublished();
		break;
	case 12: show_misc();
		break;
	}
}


/*
 * Notify callback function for `list'.
 */
int
list_select(item, string, client_data, op, event)
	Panel_item	item;
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
{

	switch(op) {
	case PANEL_LIST_OP_DESELECT:
			break;

	case PANEL_LIST_OP_SELECT:
		if (update_item() == 0)
			show_cite(string);
		break;

	}
	return XV_OK;
}


/*
 * Notify callback function for `load_file'.
 */
Panel_setting
load_file_enter(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_loadpop_objects	*ip = (bt_loadpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *	value = (char *) xv_get(item, PANEL_VALUE);
	
	load_button();
	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `load_button'.
 */
void
load_bib_file_button(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_loadpop_objects	*ip = (bt_loadpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	load_button();
}

/*
 * Notify callback function for `save_file_name'.
 */
Panel_setting
save_file_enter(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_savepop_objects	*ip = (bt_savepop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *	value = (char *) xv_get(item, PANEL_VALUE);
	
	save_button();
	return panel_text_notify(item, event);
}


/*
 * Notify callback function for `save_button'.
 */
void
save_bib_file_button(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_savepop_objects	*ip = (bt_savepop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	save_button();
}


/*
 * Notify callback function for `citekey'.
 */
Panel_setting
text_handler(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_window1_objects	*ip = (bt_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *	value = (char *) xv_get(item, PANEL_VALUE);
	
	update_item();
	next_field(item);
	return panel_text_notify(item, event);
}


/*
 * Event callback function for `window1'.
 */
Notify_value
base_event(win, event, arg, type)
	Xv_window	win;
	Event		*event;
	Notify_arg	arg;
	Notify_event_type type;
{
	bt_window1_objects	*ip = (bt_window1_objects *) xv_get(win, XV_KEY_DATA, INSTANCE);
/*	
 if (event_button_is_down(event) )
	if (update_item() == 0)
 	   return notify_next_event_func(win, (Notify_event) event, arg, type);
	else
	  	fputs("do nothing\n", stderr); 
  else*/
        expand(event);
	return notify_next_event_func(win, (Notify_event) event, arg, type);
}

/*
 * Notify callback function for `findstr'.
 */
Panel_setting
findit(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_findpop_objects	*ip = (bt_findpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *	value = (char *) xv_get(item, PANEL_VALUE);
	
	if (update_item() == 0) {
          find();
	}  
	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `findbutton'.
 */
void
find_button(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_findpop_objects	*ip = (bt_findpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	if (update_item() == 0)
		find();
}


/*
 * Notify callback function for `dismiss_annote'.
 */
void
annote_popdown(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_annotepop_objects	*ip = (bt_annotepop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xv_set(bt_annotepop->annotepop,FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
}



/*
 * Notify callback function for `dismiss_string'.
 */
void
string_popdown(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_stringpop_objects	*ip = (bt_stringpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xv_set(bt_stringpop->stringpop,FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
}

/*
 * Notify callback function for `sort_set'.
 */
void
sort_handler(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	bt_listpop_objects	*ip = (bt_listpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	if (value != sort_flag) {
	    sort_flag = value;
	    update_cite_list();
	}
}

/*
 * Notify callback function for `dismiss_ns'.
 */
void
ns_popdown(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_nspop_objects	*ip = (bt_nspop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xv_set(bt_nspop->nspop,FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
}


/*
 * Notify callback function for `dismiss_list'.
 */
void
list_popdown(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_listpop_objects	*ip = (bt_listpop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xv_set(bt_listpop->listpop,FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
}


/*
 * Done callback function for `expand'.
 */
void
expand_done(frame)
	Frame		frame;
{
	xv_set(frame, XV_SHOW, FALSE, 0);
}

/*
 * Event callback function for `ex_text'.
 */
Notify_value
expand_keys(win, event, arg, type)
	Xv_window	win;
	Event		*event;
	Notify_arg	arg;
	Notify_event_type type;
{
	bt_expand_objects	*ip = (bt_expand_objects *) xv_get(win, XV_KEY_DATA, INSTANCE);
	
	if( event_is_ascii(event) )
	  enter_expanded_text();
	if (event_action(event) == ACTION_CUT || 
	     event_action(event) == ACTION_PASTE )
		enter_expanded_text();

	return notify_next_event_func(win, (Notify_event) event, arg, type);
}

/*
 * Notify callback function for `expand_enter'.
 */
void
enter_expand(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_expand_objects	*ip = (bt_expand_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	enter_expanded_text();
}

/*
 * Notify callback function for `expand_cancel'.
 */
void
cancel_expand(item, event)
	Panel_item	item;
	Event		*event;
{
	bt_expand_objects	*ip = (bt_expand_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xv_set(bt_expand->expand,FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
}
